//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyWins1.h"
#include "CpkKeyImptDlgs1.h"
#include "CpkKeyClrDlgs.h"
#include "CpkKeyDelDlgs.h"
#include "pgpbuffers.h"
#include "pgpfiles.h"
#include "HelpDlgs.h"
#include "wipedlgs.h"
#include "msgwins.h"
#include "FileWin.h"
#include "ClipReply.h"
#include "global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TCpkKeyWin1 *CpkKeyWin1;
const AnsiString RRINGTXT = PgpRemailRing(); //MixDir()+"pubring1.asc";
//---------------------------------------------------------------------------
// TCpkkeylist
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1()
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(AnsiString filename)
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(TPGPbuffer *keys)
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(TPGPkeylist *keys)
   : TPGPkeylist()
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::TCpkKeyList1(TStrings *keys)
{
   shorts = new TStringList();
   GetAppData(shorts,CpunkShorts);
   Sorted = true;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList1::AddKeys(TStrings *keys)
{
   TPGPbuffer *KEYS = new TPGPbuffer(keys);
   int c = AddKeys(KEYS);
   delete KEYS;
   return c;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyList1::~TCpkKeyList1()
{
   delete shorts;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::LoadFromFile(AnsiString filename)
{
   TPGPbuffer *cpkkeys = new TPGPbuffer(filename);
   AddKeys(cpkkeys);
   delete cpkkeys;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList1::AddKeys(TPGPbuffer *keys)
{
   if (!keys) return 0;
   int c=0;
   keys->rewind();
   TPGPbuffer *KEY,*key = new TPGPbuffer();
   while (key->copykeyfrom(keys,REWIND))
   {  // needs copykeyfrom with rewind to parse key values
      KEY = new TPGPbuffer();
      KEY->copykeyfrom(key,REWIND);
      AnsiString addr=GetEAddress(KEY->firstuid),shrt=shorts->Values[addr];
      if (shrt.IsEmpty()) shrt = "nameless";
      AddObject(shrt+","+addr+","+"0x"+KEY->idtext8+","+KEY->algostr,KEY);
      if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
      if (addr.Length()>addrLen) addrLen = addr.Length();
      key->clear();
      c++;
   }
   delete key;
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TCpkKeyList1::AddKeys(TPGPkeylist *keys)
{
   TPGPbuffer *KEY;
   if (!keys) return 0;
//for (int i=0; i<keys->Count; i++)
//   keys->Strings[i] = keys->Strings[i]+"---"+keys->PgpKey(i)->idtext8;
//view(keys);
   for (int i=0; i<keys->Count; i++)
   {
      KEY = new TPGPbuffer(keys->PgpKey(i));
      KEY->parsekeycert();
      AnsiString addr=GetEAddress(KEY->firstuid),shrt=shorts->Values[addr];
      if (shrt.IsEmpty()) shrt = "nameless";
      AddObject(shrt+","+addr+","+"0x"+KEY->idtext8+","+KEY->algostr,KEY);
      if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
      if (addr.Length()>addrLen) addrLen = addr.Length();
   }
   return keys->Count;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList1::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   AnsiString desc;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];
   desc = PadRight(flds->Strings[0],shrtLen)+"  "+
      PadRight(flds->Strings[1],addrLen)+"  "+
      flds->Strings[2]+"  "+flds->Strings[3];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TStringList *exports = new TStringList();
   TPGPbuffer *cpkkeys = new TPGPbuffer();

   for (int i=0; i<Count; i++)
      cpkkeys->copyfrom(PgpKey(i));
   cpkkeys->exporttrust(exports);

   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (bakcopies && FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());
   exports->SaveToFile(docname);

   delete cpkkeys;
   delete exports;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyList1::GetShortAndAddressLengths(int &shrtlen, int &addrlen)
{
   shrtlen = addrlen = 0;
   for (int i=0; i<Count; i++)
   {
      AnsiString shrt=GetToken(0,Strings[i],","),addr=GetToken(1,Strings[i],",");
      if (shrt.Length()>shrtlen) shrtlen = shrt.Length();
      if (addr.Length()>addrlen) addrlen = addr.Length();
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList1::ShortName(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetToken(0,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCpkKeyList1::EAddress(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetToken(1,Strings[atPos],",");
}
//---------------------------------------------------------------------------
// TCpkKeyWin
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin1::TCpkKeyWin1(TComponent* Owner)
	: TForm(Owner)
{
   initdone = false;
   keys = new TCpkKeyList1();
   newkeys = new TStringList();
   keynodes = new TList();
   checksave = true;
   curkey = -1;
   SetHelpBtnPos();
   LoadKeys();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   Timer1->Enabled = true;
   hidedisabled = GetAppIni("HideDisabled","0")=="1";
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   GenTreeView();
   initdone = true;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyWin1::~TCpkKeyWin1()
{
   CpkKeyWin1 = NULL;
   delete keynodes;
   delete newkeys;
   delete keys;
}
//---------------------------------------------------------------------------
TPGPbuffer* __fastcall TCpkKeyWin1::GetKey(int atPos)
{
   TPGPbuffer *key = keys->PgpKey(atPos);
   if (key) key->parsekeycert();
   return key;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetTreeItemBold(TTreeNode *ANode, bool Value,
   TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::MakeMessage(TStrings *message, AnsiString &addrs,
   AnsiString &subject)
{
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RemailerConfigItemClick(TObject *Sender)
{
   TMenuItem *item=dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      AnsiString remaddrs,subject,TempName;
      if (TreeView->Selected) remaddrs = TreeView->Selected->Text;
      remaddrs = GetParam(1,remaddrs," "); if (remaddrs.IsEmpty()) return;
      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("config-request")>=0) TempName = "config-request";
      if (TempName.IsEmpty()) TempName =
          GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
      if(!TempName.IsEmpty())
      {
         AnsiString cap = Caption; Caption = "Queueing message(s)...";
         TStringList *Template = new TStringList();
         GetAppData(Template,UserTemplates+PS+TempName);
         switch (item->Tag)
         {
            case 2:
               MakeMessage(Template,remaddrs,"remailer-config");
               break;
            case 3:
               MakeMessage(Template,remaddrs,"remailer-key"   );
               break;
            case 4:
               MakeMessage(Template,remaddrs,"remailer-help"  );
               break;
            case 5:
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
            default:
               MakeMessage(Template,remaddrs,"remailer-config");
               MakeMessage(Template,remaddrs,"remailer-key"   );
               MakeMessage(Template,remaddrs,"remailer-help"  );
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
         }
         AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
         AppMainForm->Perform(WM_SHOWSTATUS,0,
            (LPARAM)"Config-request(s) created and queued");
         delete Template;
         Sleep(200);
         Caption = cap;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::GenTreeView(TCpkKeyList1 *NewKeys)
{
   TPGPbuffer *cpkkey;
   TTreeNode *node,*cnode,*unode;
   keynodes->Clear();
   TreeView->Items->Clear();
   TreeView->Items->BeginUpdate();
   TStringList *next = new TStringList();

   for (int i=0; i<keys->Count; i++)
   {
      AnsiString addr,shrt,id,idtext8,user,name,tstamp,keydesc,cpkdesc,algostr;
      if ((cpkkey=GetKey(i))!=NULL)
      {
         if (hidedisabled && (!cpkkey->enabled || cpkkey->revoked || cpkkey->expired))
            continue;

         shrt = keys->ShortName(i);
         addr = keys->EAddress(i);
         idtext8 = keys->PgpKey(i)->idtext8;
         node = TreeView->Items->AddChildObject(TreeView->Selected,
             keys->KeyDescription(i)+
            (cpkkey->revoked?"  <---REVOKED ":"")+
            (cpkkey->expired?"  <---EXPIRED ":""),
            NULL
         );
         keynodes->Add(node);

         node->ImageIndex = cpkkey->enabled ? 0:1;
         node->SelectedIndex = node->ImageIndex;
         if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);

         cnode=TreeView->Items->AddChild(node,"Name        "+shrt);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Address     "+addr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         AnsiString keyidline = "0x"+idtext8+(cpkkey->revoked?"   <---REVOKED ":"");

         cnode=TreeView->Items->AddChild(node,"Key-Id      "+keyidline);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Key-Version "+s(cpkkey->version));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Algorithm   "+cpkkey->algostr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         cnode=TreeView->Items->AddChild(node,"UserIds     "+cpkkey->firstuid);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

         TStringList *uids = new TStringList();
         cpkkey->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
         {
            unode=TreeView->Items->AddChild(cnode,uids->Strings[i]);
            unode->ImageIndex = -1; unode->SelectedIndex = -1;
         }
         delete uids;

         cnode=TreeView->Items->AddChild(node,"TimeStamp   "+cpkkey->timestr+
            (cpkkey->revoked?"  <---REVOKED ":"")+
            (cpkkey->expired?"  <---EXPIRED ":"")
         );

         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Validity    "+s(cpkkey->validity));
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
         cnode=TreeView->Items->AddChild(node,"Bits        "+cpkkey->bitsstr);
         cnode->ImageIndex = -1; cnode->SelectedIndex = -1;

      }
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   AppProcessMessages();
   delete next;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::ClearAllBtnClick(TObject *Sender)
{
   bool clrall;
   if (CpkClearKeyring(AppMainForm,clrall))
   {
      Sleep(200); int i=0; while (i<keys->Count)
      {
         if (clrall || GetKey(i)->enabled)
         {
            delete keys->Objects[i];
            keys->Delete(i);
            modified = true;
         }
         else i++;
      }
      GenTreeView();
      RefreshBtn->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon))
      DisableBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::DisableBtnClick(TObject *Sender)
{
   if (!TreeView->Selected || curkey<0 || curkey>=keys->Count) return;

   RECT r = { 0,0,50,2000 };
   TPGPbuffer *key = GetKey(curkey); key->rewind();
   bool enable=!key->enabled; key->cpkenable(enable);
   TTreeNode* node = (TTreeNode*)keynodes->Items[curkey];
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   InvalidateRect(TreeView->Handle,&r,false);

   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keys->Count) return;

   TPGPbuffer *key = keys->PgpKey(atPos);
   key->rewind();
   key->cpkenable(enable);
   TTreeNode* node = (TTreeNode*)keynodes->Items[atPos];
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   int node0 = Node->Level==0;
   RequestBtn->Enabled = node0;
   EnableDisableBtn(node0);
   //DisableBtn->Enabled = node0;
   DeleteBtn->Enabled = node0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::OkBtnClick(TObject *Sender)
{
   checksave = false;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(RRINGTXT)) zapfile(RRINGTXT,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(300);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(RRINGTXT,STATSBAKCOPIES);
   modified = false;
   newkeys->Clear();
   Caption = cap;
   Sleep(200);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
   {
      if (checksave)
      {
         switch (MsgBox("Your keyring is modified.\n\nSave your changes?",
            "Confirm",MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: break;
            default:
               SaveKeys();
         }
      }
      else SaveKeys();
   }
   SetCount(true);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::PopCollapseItemClick(TObject *Sender)
{
   TreeView->FullCollapse();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::PopExpandItemClick(TObject *Sender)
{
   TreeView->FullExpand();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SaveBtnClick(TObject *Sender)
{
   SaveKeys();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   EnableDisableBtn(false);
   //DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (!clear && WindowState!=wsMinimized && keys->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(keys->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::LoadKeys()
{
   keys->Clear();
   keys->LoadFromFile(RRINGTXT);
   keys->GetShortAndAddressLengths(sLen,aLen);
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RefreshBtnClick(TObject *Sender)
{
   if (modified && MsgBox(
      s("Your keyring is modified. Refresh from disk will discard your changes?\n\n")+
      s("Refresh now?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL) return;

   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   AnsiString cap = Caption;
   Caption = "Loading...";
   newkeys->Clear();
   keynodes->Clear();
   LoadKeys();
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(300);
   GenTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   SetRedraw(this,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::DeleteBtnClick(TObject *Sender)
{
   if (curkey<0 && curkey>=keys->Count) return;
   if (CpkDeleteKey(AppMainForm))
   {
      delete keys->Objects[curkey];
      keys->Delete(curkey);
      bool locked = LockWindowUpdate(Handle); // works much better than setredraw here
      GenTreeView();
      AppProcessMessages(); Sleep(100);
      if (locked) LockWindowUpdate(0);
      SetNothingSelected();
      RefreshBtn->Enabled = true;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::EnableDisableBtn(bool enable)
{
   Graphics::TBitmap *bitmap=DisableBtn->Bitmap;
   TCanvas *canvas=bitmap->Canvas;
   SetRedraw(DisableBtn,0);
   if (enable)
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlack) canvas->Pixels[w][h] = clBlue;
   }
   else
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlue) canvas->Pixels[w][h] = clBlack;
   }
   DisableBtn->Enabled = enable;
   SetRedraw(DisableBtn,1);
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::FormActivate(TObject *Sender)
{
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TCpkKeyList1 *impkeys = new TCpkKeyList1();
   TCpkKeyList1 *dupkeys = new TCpkKeyList1();
   ImportDir = orgDir = GetAppIni(CpkImportDir,MixDir());
   if (ImportCypherpunkKeys(this,keys,impkeys,dupkeys,ImportDir))
   {
      newkeys->Clear();
      if (impkeys->Count)
      {
         Sleep(150);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count)
      {
         BringToFront();
         AppProcessMessages();
         AddDupsImport(dupkeys);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::AddKeysImport(TCpkKeyList1 *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;

   keys->AddKeys(NewKeys);
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(300);
   GenTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   SetRedraw(this,1);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::AddDupsImport(TCpkKeyList1 *dupkeys)
{
   AnsiString dupitx8,dupshrt;
   int D,k=-1,dstamp=0,kstamp;

   AddKeysImport(dupkeys);
   for (int d=0; d<dupkeys->Count; d++)
   {
      dupitx8 = dupkeys->PgpKey(d)->idtext8;
      dupshrt = dupkeys->ShortName(d);

      for (int i=0; i<keys->Count; i++)
      {
         if (dupshrt==keys->ShortName(i) && dupitx8!=keys->PgpKey(i)->idtext8)
         {
            k = i;
            break;
         }
      }
      if (k<0)
      {
         MsgBoxHwnd(Handle,"Unable to find existing "+dupshrt+" duplicate.",
            "Error Condition",MB_OK);
         continue;
      }

      D = keys->IndexOf(dupitx8);
      if (D>=0) dstamp = keys->PgpKey(D)->timestamp;
      kstamp = keys->PgpKey(k)->timestamp;
      if (dstamp==kstamp) continue;

      if (dstamp>kstamp)
      {
         EnableKey(k,false);
         EnableKey(D,true);
      }
      else if (kstamp>dstamp)
      {
         EnableKey(k,true);
         EnableKey(D,false);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMSaveBtnClicked(TMessage& Msg)
{
   SaveBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMRefreshBtnClicked(TMessage& Msg)
{
//   RefreshAfterPGP6();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMImportBtnClicked(TMessage& Msg)
{
   ImportBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMDisableBtnClicked(TMessage& Msg)
{
   DisableBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMDeleteBtnClicked(TMessage& Msg)
{
   DeleteBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMGetKeyringMenuDat(TMessage& Msg)
{
  KeyringMenuDat *menudat = (KeyringMenuDat*)Msg.LParam;
  bool hassel = curkey>=0;
  menudat->Modified = modified;
  menudat->HasSel = hassel;
  menudat->RefreshEnabled = PopRefreshItem->Enabled; //
  menudat->CurEnabled = hassel ? keys->PgpKey(curkey)->enabled : false;
  menudat->IsPair = false;
  Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::WMKeyringNewKeyItemClicked(TMessage& Msg)
{
   //GenKeyBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "CypherpunkKeys\nCypherpunkKeysImp\nCypherpunkKeysDup",
      "Cypherpunk Key Manager",
      "Cypherpunk Keyring Manager"
   );
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyWin1::HideDisBtnClick(TObject *Sender)
{
   hidedisabled = HideDisBtn->Down;
   bool locked = LockWindowUpdate(Handle);
   GenTreeView(); AppProcessMessages();
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------

