//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FingerWins.h"
#include "FileMan.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma link "WSocket"
#pragma link "FingCli"
#pragma link "explbtn"
#pragma resource "*.dfm"
#define CR	"\r"
#define LF "\n"
#define MaxFingerCount 16
#define BUFSIZE 8092
TFingerWin *FingerWin=NULL;
//---------------------------------------------------------------------------
void __fastcall OpenFingerWin(TForm *Owner)
{
   if (!FingerWin) FingerWin = new TFingerWin(Owner);
   else FingerWin->BringToFront();
}
//---------------------------------------------------------------------------
__fastcall TFingerWin::TFingerWin(TComponent* Owner)
	: TForm(Owner)
{
   GetAppData(Query->Items,FingerHistoryKey);
   if (Query->Items->Count)
   {
      FingerBtn->Enabled = true;
      Query->ItemIndex = 0;
   }
   results = new TMemoryStream();
   lines = RichEdit1->Lines;
   RichEdit1->Clear();
   SetHelpBtnPos();
   working = false;
}
//---------------------------------------------------------------------------
__fastcall TFingerWin::~TFingerWin()
{
   FingerWin = NULL;
   delete results;
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::CancelBtnClick(TObject *Sender)
{
   Timer1->Enabled = false;
   FINGER->Abort();
   RichEdit1->Clear();
   RichEdit1->Lines->Add("Query cancelled!");
   CancelBtn->Visible = false;
   FingerBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::QueryChange(TObject *Sender)
{
   FingerBtn->Enabled = !Query->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FingerBtnClick(TObject *Sender)
{
   RichEdit1->Clear();
 	 AnsiString query = Query->Text;
   if (query.IsEmpty())
   {
      ShowMessage("No query string specified!");
      return;
   }

   TStrings *items = Query->Items;
   int idx = items->IndexOf(query);
   if (idx >= 0)
      items->Delete(idx);
   if (items->Count > 0)
      items->Insert(0,query);
   else
      items->Add(query);
   Query->ItemIndex = 0;

   if (query.Pos("@") == 0)
      query = "@"+query;
   FingerBtn->Enabled = false;
   CancelBtn->Visible = true;
   FINGER->Query = query;
   ActiveControl = Panel1;
   lines->Add("Connecting"); Timer1->Enabled = true;
   FINGER->StartQuery();
   working = true;
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FINGERSessionConnected(TObject *Sender, WORD Error)
{
   if (Error==0)
   {
      ///lines->Strings[0] = lines->Strings[0]+"Connected to host.";
      lines->Text = "Retrieving";
      Timer1->Enabled = true;
   }
   else
   {
      Timer1->Enabled = false;
      working = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FINGERDataAvailable(TObject *Sender, WORD Error)
{
   char *buf = new char[BUFSIZE];
   int len = FINGER->Receive(buf,BUFSIZE-1); buf[len] = '\0';
   results->Write(buf,len);
   delete buf;
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FINGERQueryDone(TObject *Sender, WORD Error)
{
   SetRedraw(this,0);
   Timer1->Enabled = false;
   TStrings *lines = RichEdit1->Lines;
 	 if (Error)
   {
      switch (Error)
      {
         case WSAECONNREFUSED: lines->Add("No finger service available."); break;
         case WSAETIMEDOUT: lines->Add("Host unreachable."); break;
         default:
            lines->Add("Error #"+String(Error));
      }
      MyBeep(MB_OK);
   }
   else
   {
      Sleep(300);
      ActiveControl = RichEdit1;
      CancelBtn->Visible = false;
      results->Seek(0,soFromBeginning);
      lines->LoadFromStream(results);
      FingerBtn->Enabled = true;
      AppProcessMessages();
      MyBeep(MB_OK);

      AnsiString text = Query->Text;
      if (Query->ItemIndex>=0) Query->Items->Delete(Query->ItemIndex);
      Query->Items->Insert(0,text); Query->ItemIndex = 0;
      while (Query->Items->Count>MaxFingerCount)
         Query->Items->Delete(Query->Items->Count-1);
      PutAppData(FingerHistoryKey,Query->Items);
   }
   working = false;
   SetRedraw(this,1);
}

//---------------------------------------------------------------------------
void __fastcall TFingerWin::SetHelpBtnPos()
{
   HelpBtn->Left = Width-(HelpBtn->Width+10);
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::SaveBtnClick(TObject *Sender)
{
   TSaveDialog *sd = SaveDialog1;
   if (sd->InitialDir.IsEmpty())
       sd->InitialDir = ExtractFilePath(Application->ExeName);
   sd->FileName = "*.txt";
   sd->Filter = "Text files (*.txt)|*.TXT";
   sd->Options << ofHideReadOnly;
   if (sd->Execute())
      RichEdit1->Lines->SaveToFile(SaveDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::Print1Click(TObject *Sender)
{
   RichEdit1->Print("Finger for "+Query->Text);
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::OkBtnClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (working) FINGER->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TFingerWin::Timer1Timer(TObject *Sender)
{
   if (CancelBtn->Enabled) lines->Strings[0] = lines->Strings[0] + ".";
}
//---------------------------------------------------------------------------
